<script setup lang="ts">
  const { lastElementScrolledTo } = useElementInteraction();
  const padding = ref(10);
  const el = ref<HTMLElement | null>(null);
  const { top, left, width, height } = useElementBounding(el);
  const { hoveringEl } = useTarget();
  const {
    top: topHovering,
    left: leftHovering,
    width: widthHovering,
    height: heightHovering,
  } = useElementBounding(hoveringEl);

  const positionHovering = computed(() => ({
    top: topHovering.value - padding.value + 'px',
    left: leftHovering.value - padding.value + 'px',
    height: heightHovering.value + padding.value * 2 + 'px',
    width: widthHovering.value + padding.value * 2 + 'px',
  }));

  const positionHighlighted = computed(() => ({
    top: top.value - padding.value + 'px',
    left: left.value - padding.value + 'px',
    height: height.value + padding.value * 2 + 'px',
    width: width.value + padding.value * 2 + 'px',
  }));

  watchDebounced(
    lastElementScrolledTo,
    (obj) => {
      el.value = obj?.highlightId ? document.getElementById(obj.highlightId) : null;
    },
    {
      debounce: 100,
    },
  );
</script>
<template>
  <div
    v-if="hoveringEl"
    class="bg-background-raised -z-1 pointer-events-none fixed"
    :style="positionHovering"
  />
  <div
    v-if="el && height && width"
    class="border-3 border-primary ring-3 ring-primary-disabled z-target pointer-events-none fixed rounded-xl"
    :style="positionHighlighted"
  />
</template>
